package uy.edu.fing.tse.practico.db.mapper;

import org.mapstruct.Mapper;
import org.mapstruct.factory.Mappers;
import uy.edu.fing.tse.dto.*;
import uy.edu.fing.tse.practico.db.entity.*;

import java.util.List;

@Mapper
public interface MyMapper {

    MyMapper INSTANCE = Mappers.getMapper(MyMapper.class);

    default Usuario convert(User u) {
        if (u == null) {
            return null;
        } else if (u instanceof UserBO) {
            return convert((UserBO) u);
        } else {
            return convert((UserFO) u);
        }
    }

    default User convert(Usuario u) {
        if (u == null) {
            return null;
        } else if (u instanceof UsuarioBO) {
            return convert((UsuarioBO) u);
        } else {
            return convert((UsuarioFO) u);
        }
    }

    Hecho convert(Fact f);

    Fact convert(Hecho f);

    UsuarioBO convert(UserBO u);

    UsuarioFO convert(UserFO u);

    UserBO convert(UsuarioBO u);

    UserFO convert(UsuarioFO u);

    Estado convert(State state);

    Calificacion convert(Score score);

    Categoria convert(Category category);

    TransicionEstado convert(StateHistory stateHistory);

    List<TransicionEstado> convertList1(List<StateHistory> list);

    State convert(Estado estado);

    Score convert(Calificacion calificacion);

    Category convert(Categoria categoria);

    StateHistory convert(TransicionEstado transicionEstado);

    List<StateHistory> convertList2(List<TransicionEstado> list);

    Rol convert(Role role);

    Role convert(Rol rol);

}
