package uy.edu.fing.tse.practico.business.mq;

import com.rabbitmq.client.Channel;
import com.rabbitmq.client.Connection;
import com.rabbitmq.client.ConnectionFactory;
import uy.edu.fing.tse.practico.business.common.Propiedades;

import java.io.IOException;
import java.util.concurrent.TimeoutException;

final class RabbitConfig {
    //https://barnacle.rmq.cloudamqp.com/#/queues
    private static Channel channel = null;

    private RabbitConfig() {
    }

    static Channel channel() throws IOException, TimeoutException {
        if (channel == null) {
            channel = connection().createChannel();
            for (Queue queue : Queue.values()) {
                channel.queueDeclare(queue.name, queue.durable, queue.exclusive, queue.autoDelete, null);
            }
        }
        return channel;
    }

    private static Connection connection() throws IOException, TimeoutException {
        return connectionFactory().newConnection();
    }

    private static ConnectionFactory connectionFactory() {
        ConnectionFactory factory = new ConnectionFactory();
        factory.setHost(Propiedades.HOST.getValue());
        factory.setPort(Propiedades.PORT.getIntValue());
        factory.setPassword(Propiedades.PASSWORD.getValue());
        factory.setUsername(Propiedades.USERNAME.getValue());
        factory.setVirtualHost(Propiedades.VHOST.getValue());
        return factory;
    }

}
